"use strict";

exports.__esModule = true;
exports.default = void 0;

var _events = require("events");

const defaults = {
  now: () => Date.now()
};

class Defaults extends _events.EventEmitter {
  constructor() {
    super();

    for (let key in defaults) {
      Object.defineProperty(this, key, {
        configurable: true,
        get: () => defaults[key],
        set: value => this.emit(Defaults.Events.Changed, key, defaults[key] = value)
      });
    }
  }

  get all() {
    return defaults;
  }

}

Defaults.Events = {
  Changed: 'Changed'
};
const instance = new Defaults();
var _default = instance;
exports.default = _default;