"use strict";

exports.__esModule = true;
exports.default = ErrorLogger;

var _server = _interopRequireDefault(require("../server"));

var _types = require("../store/types");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let running = false;

function ErrorLogger() {
  return store => next => action => {
    if (action.type === _types.updateGlobals && action.running !== undefined) {
      running = action.running;
    } else if (action.type === _types.log) {
      let {
        level,
        text
      } = action;

      if (!running || level === 'warn' || level === 'error') {
        console.error(text);
      }
    }

    if (action.type === _types.log && action.level !== 'error') return;
    return next(action);
  };
}