"use strict";

exports.__esModule = true;
exports.subscribe = subscribe;
exports.awaitState = awaitState;

var _redux = require("redux");

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function subscribe(store, selector, callback) {
  let state = selector(store.getState());
  return store.subscribe(() => {
    let selected = selector(store.getState()),
        old = state;

    if (typeof selected === 'object' && !Array.isArray(selected)) {
      selected = Object.entries(selected).reduce((acc, [key, value]) => state[key] !== value ? _extends({}, acc, {
        [key]: value
      }) : acc, state);
    }

    if (state !== selected) callback(state = selected, old);
  });
}

function awaitState(store, selector, condition, timeout) {
  return new Promise(resolve => {
    const cancel = timeout && setTimeout(resolve, timeout);
    const unsub = subscribe(store, selector, props => {
      const result = condition(props);

      if (result) {
        unsub();
        cancel && clearTimeout(cancel);
        resolve(result);
      }
    });
  });
}