"use strict";

exports.__esModule = true;
exports.default = _default;

var _lodash = _interopRequireDefault(require("lodash"));

var _server = _interopRequireDefault(require("../../server"));

var types = _interopRequireWildcard(require("../types"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _default(state = {
  workers: [],
  users: []
}, props) {
  switch (props.type) {
    case types.addUser:
      return _extends({}, state, {
        users: [...state.users, props.user]
      });

    case types.removeUser:
      return _extends({}, state, {
        users: state.users.filter(key => key !== props.user)
      });

    case types.addWorker:
      return _extends({}, state, {
        workers: [...state.workers, props.worker]
      });

    case types.removeWorker:
      return _extends({}, state, {
        workers: state.workers.filter(key => key !== props.worker)
      });
  }

  return state;
}