"use strict";

exports.__esModule = true;
exports.default = _default;

var _path = _interopRequireDefault(require("path"));

var types = _interopRequireWildcard(require("../types"));

var _server = _interopRequireDefault(require("../../server"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

const initial = {
  executable: 'ClassCADInstance.exe',
  configurationData: 'CADApplication.ini',
  output: _path.default.resolve('./node_modules/@awv/classcad_cadapplication'),
  protocol: 'http',
  serverOptions: {},
  ip: 'localhost',
  privatePort: 0,
  publicPort: 8181,
  binary: true,
  multipart: true,
  compression: true,
  sendTreePatches: true,
  stdout: false,
  instances: 0,
  secureApi: false,
  debug: true,
  showConsole: false,
  stateDebounce: 500,
  maxStates: 10,
  workerTimeout: 1000 * 15,
  restTimeout: 1000 * 60 * 2,
  pingTimeout: 1000 * 5,
  pingInterval: 1000 * 25,
  collectResultsOnly: true,
  logExpirationDays: 5,
  disableGraphics: false,
  enableInvisibleGraphics: false,
  enableTaskSalvaging: true,
  exec: '',
  execArgs: []
};

function _default(state = initial, props) {
  const {
    type
  } = props,
        other = _objectWithoutPropertiesLoose(props, ["type"]);

  switch (type) {
    case types.updateConfig:
      const merge = _extends({}, state, other);

      const {
        output,
        executable,
        privatePort,
        secureApi,
        binary,
        showConsole,
        debug
      } = merge;
      const isWine = ['win32', 'linux'].indexOf(process.platform) < 0;

      const binpath = _path.default.join(output, executable);

      let execArgs = isWine ? [binpath] : [];
      execArgs = [...execArgs, 'socketclient', `--port`, `${privatePort}`, '--ccwss'];
      secureApi && execArgs.push('--sapi');
      binary && execArgs.push('--binary');
      showConsole && execArgs.push('--console');
      debug && execArgs.push('--debug');
      const exec = isWine ? 'wine64' : binpath;
      return _extends({}, merge, {
        exec,
        execArgs
      });
  }

  return state;
}