"use strict";

exports.__esModule = true;
exports.default = _default;

var _moment = _interopRequireDefault(require("moment"));

var _server = _interopRequireDefault(require("../../server"));

var types = _interopRequireWildcard(require("../types"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _default(state = {
  running: false,
  spawned: 0,
  log: [],
  cpu: 0,
  tasks: 0
}, props) {
  const {
    type
  } = props,
        other = _objectWithoutPropertiesLoose(props, ["type"]);

  switch (type) {
    case types.updateGlobals:
      return _extends({}, state, other);

    case types.log:
      let log = state.log;
      if (log.length > 300) log = log.slice(log.length - 300);
      return _extends({}, state, {
        log: [...log, _extends({
          time: (0, _moment.default)().format('YYYY-MM-DD HH:mm:ss'),
          level: props.level,
          text: props.text
        }, props.args)]
      });
  }

  return state;
}