"use strict";

exports.__esModule = true;
exports.default = _default;

var _lodash = _interopRequireDefault(require("lodash"));

var _server = _interopRequireDefault(require("../../server"));

var _defaults = _interopRequireDefault(require("../../defaults"));

var types = _interopRequireWildcard(require("../types"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _default(state = [], props) {
  // 'worker' field should not be present, or else it should not mutate global tasks
  // When the field is present it would mean that the task is managed as a worker-task
  // The only exception is claimWorker, which removes global tasks now belonging to a worker
  if (props.worker && props.type !== types.claimWorker) return state;

  switch (props.type) {
    case types.pushTask:
      return [...state, {
        id: props.task,
        user: props.user,
        commands: props.commands,
        promise: props.promise,
        resolve: props.resolve,
        reject: props.reject,
        timestamp: props.timestamp || _defaults.default.now(),
        duration: 0,
        results: [],
        streamData: {}
      }];

    case types.claimWorker:
      return state.filter(t => t.user !== props.user);

    case types.removeTask:
      return state.filter(t => t.id !== props.task);

    case types.updateTask:
      return state.map(t => t.id === props.task ? _extends({}, t, {
        results: [...t.results, ...props.results],
        streamData: _extends({}, t.streamData, props.streamData)
      }) : t);
  }

  return state;
}