"use strict";

exports.__esModule = true;
exports.default = _default;

var _lodash = _interopRequireDefault(require("lodash"));

var _server = _interopRequireDefault(require("../../server"));

var _defaults = _interopRequireDefault(require("../../defaults"));

var types = _interopRequireWildcard(require("../types"));

var _tasks = _interopRequireDefault(require("./tasks"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _default(state = {}, props) {
  const {
    worker
  } = props,
        other = _objectWithoutPropertiesLoose(props, ["worker"]);

  switch (props.type) {
    case types.addWorker:
      return _extends({}, state, {
        [worker]: {
          id: worker,
          socket: props.socket,
          process: props.process,
          lastUser: undefined,
          occupied: false,
          alive: true,
          tasks: [],
          timestamp: _defaults.default.now(),
          sequence: Promise.resolve(),
          resolve: undefined
        }
      });

    case types.updateWorker:
      return _extends({}, state, {
        [worker]: _extends({}, state[worker], props.updates)
      });

    case types.removeWorker:
      return _lodash.default.omit(state, worker);

    case types.claimWorker:
      return _extends({}, state, {
        [worker]: _extends({}, state[worker], {
          tasks: [...state[worker].tasks, ...props.tasks],
          occupied: true,
          lastUser: props.user || state[worker].lastUser,
          timestamp: _defaults.default.now(),
          sequence: props.sequence || state[worker].sequence,
          resolve: props.resolve || state[worker].resolve
        })
      });

    case types.releaseWorker:
      return _extends({}, state, {
        [worker]: _extends({}, state[worker], {
          occupied: false,
          timestamp: _defaults.default.now()
        })
      });

    case types.removeTask:
    case types.pushTask:
    case types.updateTask:
      if (!worker) return state; // We re-use the task-reducer here, but since both places now share the same semantics
      // we have to extract the 'worker' field in order to not disturb global task reducing

      return _extends({}, state, {
        [worker]: _extends({}, state[worker], {
          tasks: (0, _tasks.default)(state[worker].tasks, other),
          timestamp: _defaults.default.now()
        })
      });
  }

  return state;
}